***********************

  list.c

**********************


#include "list.h"

/*******************

ꥹؿ

********************/
/*----------------------------------------------
   PARTICLE򿷵­
   ѥ᡼state,x,yȥꥹȤƬΥݥ󥿡*/

struct PARTICLE * add_PARTICLE_x(signed char state, double x, double y, struct BCELL *startP){

  struct BCELL *currentBC;

  struct PARTICLE *tempP;

  int intx, inty;

  intx = (int)x;
  inty = (int)y;

  /* ޤ find_BCELL ,äx,yбBCELLؤΥݥ󥿤 */
  currentBC = find_BCELL(intx, inty, startP);
  
  /* BCELLθĿǥå
  (currentBC->index[state])++; */ 

  /* add_listѤPARTICLEɲ */
  tempP =  add_list_x(state, x, y, currentBC);

  /* void֤ͥʥ*/

  return tempP;
}
/*----------------------------------------------
   PARTICLE򿷵­
   ѥ᡼state,x,yȥꥹȤƬΥݥ󥿡*/

void add_PARTICLE(signed char state, double x, double y, struct BCELL *startP){

  struct BCELL *currentBC;
  int intx, inty;

  intx = (int)x;
  inty = (int)y;

  /* ޤ find_BCELL ,äx,yбBCELLؤΥݥ󥿤 */
  currentBC = find_BCELL(intx, inty, startP);
  
  /* BCELLθĿǥå
  (currentBC->index[state])++; */ 

  /* add_listѤPARTICLEɲ */
  add_list(state, x, y, currentBC);

  /* void֤ͥʥ*/

}

/*---------------------------------------------------------------
  x,yBCELLPARTICLEΥإåʬˤؤݥ󥿤֤  */

struct BCELL *find_BCELL(int x, int y, struct BCELL *startBC){

  int i,num;

  num=MAX_X-x-1+(MAX_Y-y-1)*MAX_X;

  for(i=0;i<num;i++)
    startBC=startBC->next;

  return startBC;

}

/*------------------------------------
  startΥݥ󥿡NULLˤä
  BCELLΥꥹȤ򥤥롣     */

struct BCELL *init_BCELL(struct BCELL *startP){

  struct BCELL *newP, *tempP;
  int i,j,k;

  /* éǰ켡BCELLꥹȤ */

  tempP=startP;

  for(i=0;i<MAX_Y;i++){
    for(j=0;j<MAX_X;j++){
      
      newP = malloc(sizeof(struct BCELL));
      if(newP == NULL){
	printf("Out of memory\n");
	exit(8);
      }

      /* ץǥåϤ٤ƥˤ */
      for(k=0;k<P_ID_NUM;k++){
	  newP->index[k]=0;
      }

      /* cx,cyͤ */
      newP->cx = j;
      newP->cy = i;

      /* PARTICLEؤΥݥ󥿤NULL */
      newP->pnext = NULL;

      /* PARTICLEդ­ */
      newP->next = tempP;
      tempP=newP;

    }
  }

  return tempP;

}

/*--------------------------------------------------
   add_list ꥹȤɲä롣
   ѥ᥿state,x,yդ­BCELLؤΥݥ */

struct PARTICLE *add_list_x(signed char newstate, double newx, double newy, struct BCELL *firstBC){

  struct PARTICLE *newP;

  newP = malloc(sizeof(struct PARTICLE));
  if(newP == NULL){
    printf("Out of memory\n");
    exit(8);
  }

  newP->state = newstate;
  newP->x = newx;
  newP->y = newy;

  /* ݥ󥿤Ĥʤ碌 */
  newP->next = firstBC->pnext;
  newP->back = NULL;

  if(firstBC->pnext != NULL){
    (firstBC->pnext)->back = newP;
  }
  firstBC->pnext = newP;

  return newP;
}

/*--------------------------------------------------
   add_list ꥹȤɲä롣
   ѥ᥿state,x,yդ­BCELLؤΥݥ */

void add_list(signed char newstate, double newx, double newy, struct BCELL *firstBC){

  struct PARTICLE *newP;

  newP = malloc(sizeof(struct PARTICLE));
  if(newP == NULL){
    printf("Out of memory\n");
    exit(8);
  }

  newP->state = newstate;
  newP->x = newx;
  newP->y = newy;

  /* ݥ󥿤Ĥʤ碌 */
  newP->next = firstBC->pnext;
  newP->back = NULL;

  if(firstBC->pnext != NULL){
    (firstBC->pnext)->back = newP;
  }
  firstBC->pnext = newP;
}

/*------------------------------------------------
   find_list ꥹȤʬID򥭡ˤƸ롣
   ѥ᥿ϸstatestartΥݥ󥿡           ̤ */

struct PARTICLE *find_list(signed char dest, struct PARTICLE *firstP){

  struct PARTICLE *currentP;

  currentP = firstP;

  while(currentP != NULL){
    if(currentP->state == dest)
      break;
     currentP = currentP->next;
  }

  return ((currentP == NULL)? NULL : currentP);
}

/*------------------------------------------------
   delete_list ꥹȤõ롣
   ѥ᥿ϾõPARTICLEؤΥݥ󥿡               ̤  */

void delete_list(struct PARTICLE *currentP, struct BCELL *start){

  struct PARTICLE *tempnextP, *tempbackP, *tempnextBCP;
  struct BCELL *fromBC;

  /* ߤPARTICLE°ꥹȤPARTICLEΥݥ󥿤 */

  tempnextP = currentP->next;
  tempbackP = currentP->back; 

  fromBC = find_BCELL((int)floor(currentP->x), (int)floor(currentP->y), start);

  if(tempnextP != NULL && tempbackP != NULL){

    tempbackP->next = tempnextP;
    tempnextP->back = tempbackP;

  }
  else if(tempnextP != NULL && tempbackP == NULL){

    fromBC->pnext = tempnextP;
    tempnextP->back = NULL;

  }
  else if(tempnextP == NULL && tempbackP != NULL){

    tempbackP->next = NULL;

  }
  else{

    fromBC->pnext = NULL;

  }

  free(currentP);
  currentP = NULL;

}

/*---------------------------------------------------
  PARTICLEꤵ줿BCELL˰ưؿ
  move_PARTICLE */

void move_PARTICLE(struct PARTICLE *currentP, struct BCELL *fromBC, struct BCELL *toBC){

  struct PARTICLE *tempnextP, *tempbackP, *tempnextBCP;
  

  /* ߤPARTICLE°ꥹȤPARTICLEΥݥ󥿤 */

  tempnextP = currentP->next;
  tempbackP = currentP->back; 
  tempnextBCP = toBC->pnext;

  if(tempnextP != NULL && tempbackP != NULL){
 
    tempbackP->next = tempnextP;
    tempnextP->back = tempbackP;

  }
  else if(tempnextP != NULL && tempbackP == NULL){
 
    fromBC->pnext = tempnextP;
    tempnextP->back = NULL;

  }
  else if(tempnextP == NULL && tempbackP != NULL){
 
    tempbackP->next = NULL;

  }
  else{
 
    fromBC->pnext = NULL;

  }

  currentP->next = NULL;
  currentP->back = NULL;
  
  if(tempnextBCP != NULL){
 
    toBC->pnext = currentP;
    currentP->next = tempnextBCP;
    tempnextBCP->back = currentP;
    
  }
  else{
 
    toBC->pnext = currentP;
    currentP->next = NULL;
    currentP->back = NULL;
  }

}

/* -----------------------------------------------
   PARTICLE夲,BCELL->index[]˳Ǽ */

void counting(struct BCELL *currentBC, struct AMOUNT *currentAM){

  struct PARTICLE *currentP;
  int i;
  int allindex[20];

  for(i=0;i<20;i++){
    allindex[i]=0;
  }

  while(currentBC != NULL){

    currentP = currentBC->pnext;

    for(i=0;i<P_ID_NUM+2;i++){

      currentBC->index[i]=0;

    }

    while(currentP != NULL){

      currentP->state = abs(currentP->state);
      allindex[currentP->state]++;
      currentBC->index[currentP->state]++;
      currentP = currentP->next;

    }

    currentBC = currentBC->next;

  }
 
  for(i=0;i<20;i++){
 
    currentAM->amount[i] = allindex[i];
  }

   
  printf("%d ",allindex[4]);
  printf("%d \n",allindex[3]);
  
}
  
