/********************

  顼
  ץ

  outtoppm.c

  ******************/

#include "outtoppm.h"
#include "list.h"

void createimage(struct BCELL *startP, char *name){

  FILE *fp;
  struct BCELL *currentP;
  int tempcol[3];
  int i,j;

  /* BCELLindexȳݤcreateimageǽϤ
   RGBͤ׻롣夫R,G,Bν硣 */
  
  unsigned char COL_TABLE[3][20] =
  {
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    { 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    { 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
  };

  

  currentP=startP;

  fp = fopen(name, "w");

  if(fp != NULL){

    fprintf(fp, "P3\n%d %d\n255\n",MAX_X,MAX_Y); 

    while(currentP != NULL){

      for(j=0;j<3;j++){
	tempcol[j]=0;

	for(i=0;i<20;i++){
	  tempcol[j] += currentP->index[i] * COL_TABLE[j][i];
	}

	if(tempcol[j]>255) tempcol[j] = 255;

      }

      fprintf(fp, "%d %d %d ",tempcol[0],tempcol[1],tempcol[2]);

      currentP = currentP->next;

    }

    fclose(fp);

  }

}
